## org.eclipse.datatools.enablement.sybase.ddl
Class SybaseDdlGenerator

    java.lang.Object
      org.eclipse.datatools.connectivity.sqm.core.rte.fe.GenericDdlGenerator
          org.eclipse.datatools.enablement.sybase.ddl.SybaseDdlGenerator

All Implemented Interfaces:
  DDLGenerator, ISybaseDdlGenerator

Direct Known Subclasses:
  SybaseASADdlGenerator, SybaseASEDdlGenerator

    public abstract class SybaseDdlGenerator

extends GenericDdlGenerator
implements ISybaseDdlGenerator, DDLGenerator

provide sckeletal implementation for database specified DdlGenrator, such as ASEDdlGenerator, ASADdlGenerator, IQDdlGenerator

Author:
  linsong

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.datatools.connectivity.sqm.core.rte.fe.GenericDdlGenerator
`GenericDdlGenerator.SingletonOptionDependency`

Field Summary
`static byte` `GENERATE_COMMENTS_GEN_OPTION_INDEX`
`static byte` `GENERATE_CREATE_STATEMENTS_GEN_OPTION_INDEX`
`static byte` `GENERATE_DROP_STATEMENTS_GEN_OPTION_INDEX`
`static byte` `GENERATE_FULL_SYNTAX_GEN_OPTION_INDEX`
`static byte` `GENERATE_FULLY_QUALIFIED_NAME_GEN_OPTION_INDEX`
`static byte` `GENERATE_PRIVILEGES_GEN_OPTION_INDEX`
`static byte` `GENERATE_QUOTED_IDENTIFIER_GEN_OPTION_INDEX`
`static byte` `GENERATE_SETUSER_GEN_OPTION_INDEX`
`static byte` `GENERATE_USEDATABASE_GEN_OPTION_INDEX`

Constructor Summary
`SybaseDdlGenerator()`

Method Summary
`static EngineeringOption` `createEngineeringOption(EngineeringOption oldOption)`
`EngineeringOption[]` `createGenerationOptions()`
`static EngineeringOption[]` `createOptions(byte[] optionIndices)`
`java.lang.String[]` `createSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, boolean fullSyntax, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`java.lang.String[]` `createSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`java.lang.String[]` `createSQLObjects(SQLObject[] elements, EngineeringOption[] options, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`void` `createStatement(SQLObject element, boolean quoteIdentifiers, boolean qualifyNames, boolean fullSyntax, SybaseDdlScript script, org.eclipse.core.runtime.IProgressMonitor progressMonitor, int task)`
`java.lang.String[]` `dropSQLObjects(SQLObject[] elements, boolean quoteIdentifiers, boolean qualifyNames, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`java.lang.String[]` `dropSQLObjects(SQLObject[] elements, EngineeringOption[] options, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`void` `dropStatement(SQLObject element, boolean quoteIdentifiers, boolean qualifyNames, SybaseDdlScript script, org.eclipse.core.runtime.IProgressMonitor progressMonitor, int task)`
`java.lang.String[]` `generateDDL(SQLObject[] elements, EngineeringOption[] options, org.eclipse.core.runtime.IProgressMonitor progressMonitor)` generate specified elements ddl script, which style following the specified options
`java.lang.String[]` `generateDDL(SQLObject[] elements, org.eclipse.core.runtime.IProgressMonitor progressMonitor)`
`boolean` `generateFullSyntax(EngineeringOption[] options)` generate full syntax or not
`boolean` `generateSetUser(EngineeringOption[] options)` generate setuser statement or not
`boolean` `generateUseDatabase(EngineeringOption[] options)` generate use database statement or not
`abstract byte[]` `getAdditionalOptionIndices(int objectType)`
`EngineeringOption[]` `getAdditionalOptions(int objectType)`
`byte[]` `getCommonAdditionalOptionIndices(int objectType)`
`byte[]` `getCommonGenerateOptionIndices()`
`abstract byte[]` `getExclusiveAdditionalOptionIndices(int objectType)`
`abstract byte[]` `getGenerationOptionIndices(int objectType)`
`EngineeringOption[]` `getGenerationOptions(int objectType)`
`EngineeringOption` `getOptionByID(java.lang.String optionID, EngineeringOption[] options)`
`EngineeringOption[]` `getOptions()`
`java.lang.Object` `getParameter()`
`SybaseDdlBuilder` `getSybaseDdlBuilder()`
`void` `setParameter(java.lang.Object obj)`

Methods inherited from class org.eclipse.datatools.connectivity.sqm.core.rte.fe.GenericDdlGenerator

`createSQLObjects, dropSQLObjects, generateAssertions, generateCKConstraints, generateCommentStatement, generateCreateStatement, generateDatabase, generateDDL, generateDropStatement, generateFKConstraints, generateFullyQualifiedNames, generateFunctions, generateIndexes, generatePKConstraints, generateQuotedIdentifiers, generateSchemas, generateSequences, generateStoredProcedures, generateTables, generateTriggers, generateUserDefinedTypes, generateViews, getOptionCategories, getOptions, getSelectedOptions`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.eclipse.datatools.enablement.sybase.ddl.ISybaseDdlGenerator
`createSQLObjectsForDeltaDDL, dropSQLObjectsForDeltaDDL`

Methods inherited from interface org.eclipse.datatools.connectivity.sqm.core.rte.DDLGenerator
`createSQLObjects, dropSQLObjects, generateDDL, getOptionCategories, getOptions`

Field Detail

### GENERATE_CREATE_STATEMENTS_GEN_OPTION_INDEX

    public static final byte GENERATE_CREATE_STATEMENTS_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_DROP_STATEMENTS_GEN_OPTION_INDEX

    public static final byte GENERATE_DROP_STATEMENTS_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_FULLY_QUALIFIED_NAME_GEN_OPTION_INDEX

    public static final byte GENERATE_FULLY_QUALIFIED_NAME_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_QUOTED_IDENTIFIER_GEN_OPTION_INDEX

    public static final byte GENERATE_QUOTED_IDENTIFIER_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_FULL_SYNTAX_GEN_OPTION_INDEX

    public static final byte GENERATE_FULL_SYNTAX_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_PRIVILEGES_GEN_OPTION_INDEX

    public static final byte GENERATE_PRIVILEGES_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_COMMENTS_GEN_OPTION_INDEX

    public static final byte GENERATE_COMMENTS_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_SETUSER_GEN_OPTION_INDEX

    public static final byte GENERATE_SETUSER_GEN_OPTION_INDEX

See Also:
  Constant Field Values

### GENERATE_USEDATABASE_GEN_OPTION_INDEX

    public static final byte GENERATE_USEDATABASE_GEN_OPTION_INDEX

See Also:
  Constant Field Values

Constructor Detail

### SybaseDdlGenerator

    public SybaseDdlGenerator()

Method Detail

### getOptions

    public EngineeringOption[] getOptions()

  Returns:
    all global EngineeringOption array

### createGenerationOptions

    public EngineeringOption[] createGenerationOptions()

  Specified by:
    `createGenerationOptions` in interface `ISybaseDdlGenerator`
  Returns:
    cloned generate options array

### getGenerationOptions

    public EngineeringOption[] getGenerationOptions(int objectType)

### getAdditionalOptions

    public EngineeringOption[] getAdditionalOptions(int objectType)

  Specified by:
    `getAdditionalOptions` in interface `ISybaseDdlGenerator`
  Returns:
    cloned additional options apply for spefied object type

### createOptions

    public static EngineeringOption[] createOptions(byte[] optionIndices)

  Parameters:
    `optionIndices` -
  Returns:
    cloned specified option index options

### createEngineeringOption

    public static EngineeringOption createEngineeringOption(EngineeringOption oldOption)

### getCommonGenerateOptionIndices

    public byte[] getCommonGenerateOptionIndices()

### generateDDL

    public java.lang.String[] generateDDL(SQLObject[] elements,
                                          EngineeringOption[] options,
                                          org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Description copied from interface: `ISybaseDdlGenerator`
  generate specified elements ddl script, which style following the specified options

  Specified by:
    `generateDDL` in interface `ISybaseDdlGenerator`
  Parameters:
    `elements` -
    `progressMonitor` -
    `tableSet` - all tables contained in the tableSet will generate contained objects' ddl
    `options` -
  Returns:

### generateDDL

    public java.lang.String[] generateDDL(SQLObject[] elements,
                                          org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `generateDDL` in interface `DDLGenerator`
  Overrides:
    `generateDDL` in class `GenericDdlGenerator`

### createSQLObjects

    public java.lang.String[] createSQLObjects(SQLObject[] elements,
                                               EngineeringOption[] options,
                                               org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `createSQLObjects` in interface `ISybaseDdlGenerator`
  Returns:

### createSQLObjects

    public java.lang.String[] createSQLObjects(SQLObject[] elements,
                                               boolean quoteIdentifiers,
                                               boolean qualifyNames,
                                               org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `createSQLObjects` in interface `DDLGenerator`
  Overrides:
    `createSQLObjects` in class `GenericDdlGenerator`

### createSQLObjects

    public java.lang.String[] createSQLObjects(SQLObject[] elements,
                                               boolean quoteIdentifiers,
                                               boolean qualifyNames,
                                               boolean fullSyntax,
                                               org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `createSQLObjects` in interface `ISybaseDdlGenerator`

### dropSQLObjects

    public java.lang.String[] dropSQLObjects(SQLObject[] elements,
                                             boolean quoteIdentifiers,
                                             boolean qualifyNames,
                                             org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `dropSQLObjects` in interface `DDLGenerator`
  Overrides:
    `dropSQLObjects` in class `GenericDdlGenerator`

### dropSQLObjects

    public java.lang.String[] dropSQLObjects(SQLObject[] elements,
                                             EngineeringOption[] options,
                                             org.eclipse.core.runtime.IProgressMonitor progressMonitor)

  Specified by:
    `dropSQLObjects` in interface `ISybaseDdlGenerator`
  Returns:

### createStatement

    public void createStatement(SQLObject element,
                                boolean quoteIdentifiers,
                                boolean qualifyNames,
                                boolean fullSyntax,
                                SybaseDdlScript script,
                                org.eclipse.core.runtime.IProgressMonitor progressMonitor,
                                int task)

### dropStatement

    public void dropStatement(SQLObject element,
                              boolean quoteIdentifiers,
                              boolean qualifyNames,
                              SybaseDdlScript script,
                              org.eclipse.core.runtime.IProgressMonitor progressMonitor,
                              int task)

### generateFullSyntax

    public boolean generateFullSyntax(EngineeringOption[] options)

  generate full syntax or not

  Returns:

### generateSetUser

    public boolean generateSetUser(EngineeringOption[] options)

  generate setuser statement or not

  Returns:

### generateUseDatabase

    public boolean generateUseDatabase(EngineeringOption[] options)

  generate use database statement or not

  Returns:

### getOptionByID

    public EngineeringOption getOptionByID(java.lang.String optionID,
                                           EngineeringOption[] options)

### getAdditionalOptionIndices

    public abstract byte[] getAdditionalOptionIndices(int objectType)

  Parameters:
    `objectType` - database object type
  Returns:
    additional database option indices

### getExclusiveAdditionalOptionIndices

    public abstract byte[] getExclusiveAdditionalOptionIndices(int objectType)

### getGenerationOptionIndices

    public abstract byte[] getGenerationOptionIndices(int objectType)

### getCommonAdditionalOptionIndices

    public byte[] getCommonAdditionalOptionIndices(int objectType)

### getSybaseDdlBuilder

    public SybaseDdlBuilder getSybaseDdlBuilder()

### setParameter

    public void setParameter(java.lang.Object obj)

### getParameter

    public java.lang.Object getParameter()